/***********************************************/
/* Im Beispiel wird 4 x die Variable a deklariert
/***********************************************/
#include <stdio.h>

/************************************/
/* Deklaration der Funktion summe() */
/************************************/
int  summe (int, int); 

/*********************************************************/
/* Deklaration von globalen Variablen                    */
/*********************************************************/
int a = 1;

/*********************************************************/
/* Hauptprogramm                                         */
/*********************************************************/
int main()
{
    printf("start %d\n",a);
    int a=2;	/* a in main() = 2 und ueberdeckt globales a*/	
    printf("1.stelle %d\n",a);
    {
	int a=2;  /* lokales a in main() = 2 und ueberdeckt a in main() */
	printf("2.stelle %d\n",a);
	a=a+1;	  /* lokales a in main() wird um 1 erh\"oht */
	printf("3.stelle %d\n",a);
	a=summe(a,a);	/* lokales a in main() = 2 x lokales a in main() 
			 * Gleichzeitig wird das globale a in
			 * der Funktion summe um 1 erh\"oht */
	/* lokales a in main() wird gel\"oscht */
	printf("4.stelle %d\n",a);
    }
    printf("5.stelle %d\n",a);
    a=summe(a,a);	 /* a in main = 2 x lokales a in main() 
			  * Gleichzeitig wird das globale a in
			  * der Funktion summe um 1 erh\"oht */
    printf("6.stelle %d\n",a);
    
    return 0;
}

/****************************************************************/
/* Definition Summen-Funktion */
/****************************************************************/
int summe (int x, int y)
{	
    /* Die Funktion summe() erstellt Kopien
     * der Funktionswerte (reserviert neuen Speicher)
     * und speichert sie in x bzw. y */
    
    printf("summe: 1.stelle %d\n",a);
    a=a+1; /* globales a wird um 1 erh\"oht */
    printf("summe: 2.stelle %d\n",a);
    
    int a=0;	/* a in der Funktion summe() */
    printf("summe: 3.stelle %d\n",a);
    a=x+y;		/* a in der Funktion summe = x+y */
    printf("summe: 4.stelle %d\n",a);
    
    return a;	/* a in der Funktion wird zur\"uckgegeben */
    
    /* a,x,y in der Funktion summe werden gel\"oscht */	
}	
